#include "blueprint.h"
#include "builtin.h"
#include "context.h"

typedef struct
{
	blueprint * bp;
} l_Build;

Func(Build,
	NumParams 1,
	CallSpace 1,
	l_Build)
	
	Param(0, TYPE_BLUEPRINT)
	
	locals->bp = ((t_Blueprint *)(cdata->params[0]))->bp;
	release_ref(cdata->params[0]);
	
	Ret(0, new_object_bp(locals->bp))
EndFunc

object * make_Blueprint(int32_t type_id)
{
	t_Blueprint * obj;
	object * ret = new_object(TYPE_BLUEPRINT);
	obj = (t_Blueprint *)ret;
	obj->bp = get_blueprint_byid(type_id);
	return ret;
}
